PF-build.sh 45 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_36
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. # 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
  139. #### Start check if OSTYPE is supported
  140. OS_FOUND=$( command -v uname)
  141. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  142. linux*)
  143. TARGET_OS="linux"
  144. ;;
  145. msys*|cygwin*|mingw*)
  146. # or possible 'bash on windows'
  147. TARGET_OS='windows'
  148. ;;
  149. nt|win*)
  150. TARGET_OS='windows'
  151. ;;
  152. *)
  153. TARGET_OS='unknown'
  154. ;;
  155. esac
  156. # Windows
  157. if [ $TARGET_OS == "windows" ]; then
  158. if [ $(uname -m) == "x86_64" ]; then
  159. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  160. Processor="64"
  161. elif [ $(uname -m) == "i386" ]; then
  162. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  163. Processor="32"
  164. else
  165. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  166. echo "Please refer to the notes of build.sh$(tput sgr0)"
  167. exit 1
  168. fi
  169. # Linux
  170. elif [ $TARGET_OS == "linux" ]; then
  171. if [ $(uname -m) == "x86_64" ]; then
  172. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  173. Processor="64"
  174. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  175. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  176. Processor="32"
  177. else
  178. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  179. echo "Please refer to the notes of build.sh$(tput sgr0)"
  180. exit 1
  181. fi
  182. else
  183. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  184. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  185. echo "Read the notes of build.sh$(tput sgr0)"
  186. exit 1
  187. fi
  188. sleep 2
  189. #### End check if OSTYPE is supported
  190. #### Prepare bash environment and check if wget, zip and other needed things are available
  191. # Check wget
  192. if ! type wget > /dev/null; then
  193. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  194. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  195. exit 2
  196. fi
  197. # Check for zip
  198. if ! type zip > /dev/null; then
  199. if [ $TARGET_OS == "windows" ]; then
  200. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  201. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  202. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  203. echo "Run git Bash under Administrator privilege and"
  204. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  205. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  206. exit 3
  207. elif [ $TARGET_OS == "linux" ]; then
  208. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  209. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  210. #sudo apt-get update && apt-get install zip
  211. exit 3
  212. fi
  213. fi
  214. # Check python ... needed during language build
  215. if ! type python > /dev/null; then
  216. if [ $TARGET_OS == "windows" ]; then
  217. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  218. exit 4
  219. elif [ $TARGET_OS == "linux" ]; then
  220. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  221. echo "As Python 2.x will not be maintained from 2020 please,"
  222. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  223. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  224. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  225. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  226. exit 4
  227. fi
  228. fi
  229. # Check gawk ... needed during language build
  230. if ! type gawk > /dev/null; then
  231. if [ $TARGET_OS == "linux" ]; then
  232. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  233. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  234. #sudo apt-get update && apt-get install gawk
  235. exit 4
  236. fi
  237. fi
  238. #### End prepare bash / Linux environment
  239. #### Set build environment
  240. ARDUINO_ENV="1.8.5"
  241. BUILD_ENV="1.0.6"
  242. BOARD="prusa_einsy_rambo"
  243. BOARD_PACKAGE_NAME="PrusaResearch"
  244. BOARD_VERSION="1.0.3"
  245. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  246. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  247. BOARD_FILENAME="prusa3dboards"
  248. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  249. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  250. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  251. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  252. LIB="PrusaLibrary"
  253. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  254. # List few useful data
  255. echo
  256. echo "Script path :" $SCRIPT_PATH
  257. echo "OS :" $OS
  258. echo "OS type :" $TARGET_OS
  259. echo ""
  260. echo "Arduino IDE :" $ARDUINO_ENV
  261. echo "Build env :" $BUILD_ENV
  262. echo "Board :" $BOARD
  263. echo "Package name:" $BOARD_PACKAGE_NAME
  264. echo "Board v. :" $BOARD_VERSION
  265. echo "Specific Lib:" $LIB
  266. echo ""
  267. #### Start prepare building environment
  268. #Check if build exists and creates it if not
  269. if [ ! -d "../PF-build-dl" ]; then
  270. mkdir ../PF-build-dl || exit 5
  271. fi
  272. cd ../PF-build-dl || exit 6
  273. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  274. # Check if PF-build-env-<version> exists and downloads + creates it if not
  275. # The build environment is based on the supported Arduino IDE portable version with some changes
  276. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  277. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  278. mkdir ../PF-build-env-$BUILD_ENV
  279. sleep 5
  280. fi
  281. # Download and extract supported Arduino IDE depending on OS
  282. # Windows
  283. if [ $TARGET_OS == "windows" ]; then
  284. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  285. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  286. sleep 2
  287. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  288. echo "$(tput sgr 0)"
  289. fi
  290. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  291. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  292. sleep 2
  293. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  294. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  295. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  296. echo "$(tput sgr0)"
  297. fi
  298. fi
  299. # Linux
  300. if [ $TARGET_OS == "linux" ]; then
  301. # 32 or 64 bit version
  302. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  303. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  304. sleep 2
  305. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  306. echo "$(tput sgr 0)"
  307. fi
  308. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  309. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  310. sleep 2
  311. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  312. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  313. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  314. echo "$(tput sgr0)"
  315. fi
  316. fi
  317. # Make Arduino IDE portable
  318. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  319. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  320. fi
  321. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  322. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  323. fi
  324. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  325. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  326. fi
  327. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  328. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  329. fi
  330. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  331. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  332. fi
  333. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  334. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  335. fi
  336. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  337. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  338. fi
  339. # Change Arduino IDE preferences
  340. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  341. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  342. sleep 2
  343. echo "update.check"
  344. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  345. echo "board"
  346. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  347. echo "editor.linenumbers"
  348. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  349. echo "boardsmanager.additional.urls"
  350. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  351. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  352. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  353. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  354. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  355. echo "$(tput sgr0)"
  356. fi
  357. # Download and extract Prusa Firmware related parts
  358. # Download and extract PrusaResearchRambo board
  359. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  360. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  361. sleep 2
  362. wget $BOARD_FILE_URL || exit 9
  363. fi
  364. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  365. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  366. sleep 2
  367. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  368. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  369. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  370. fi
  371. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  372. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  373. fi
  374. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  375. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  376. fi
  377. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  378. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  379. fi
  380. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  381. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  382. echo "$(tput sgr 0)"
  383. fi
  384. # Download and extract Prusa Firmware specific library files
  385. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  386. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  387. sleep 2
  388. wget $PF_BUILD_FILE_URL || exit 11
  389. echo "$(tput sgr 0)"
  390. fi
  391. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  392. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  393. sleep 2
  394. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  395. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  396. echo "$(tput sgr0)"
  397. fi
  398. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  399. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  400. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  401. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  402. sleep 2
  403. fi
  404. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  405. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  406. sleep 2
  407. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  408. sleep 2
  409. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  410. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  411. echo "$(tput sgr0)"
  412. fi
  413. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  414. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  415. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  416. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  417. sleep 2
  418. echo "$(tput sgr0)"
  419. exit 13
  420. fi
  421. #### End prepare building
  422. #### Start
  423. cd $SCRIPT_PATH
  424. # Check if git is available
  425. if type git > /dev/null; then
  426. git_available="1"
  427. fi
  428. while getopts v:l:d:b:o:c:p:n:?h flag
  429. do
  430. case "${flag}" in
  431. v) variant_flag=${OPTARG};;
  432. l) language_flag=${OPTARG};;
  433. d) devel_flag=${OPTARG};;
  434. b) build_flag=${OPTARG};;
  435. o) output_flag=${OPTARG};;
  436. c) clean_flag=${OPTARG};;
  437. p) prusa_flag=${OPTARG};;
  438. n) new_build_flag=${OPTARG};;
  439. ?) help_flag=1;;
  440. h) help_flag=1;;
  441. esac
  442. done
  443. #echo "variant_flag: $variant_flag";
  444. #echo "language_flag: $language_flag";
  445. #echo "devel_flag: $devel_flag";
  446. #echo "build_flag: $build_flag";
  447. #echo "output_flag: $output_flag";
  448. #echo "help_flag: $help_flag"
  449. #echo "clean_flag: $clean_flag"
  450. #echo "prusa_flag: $prusa_flag"
  451. #echo "new_build_flag: $new_build_flag"
  452. #
  453. # '?' 'h' argument usage and help
  454. if [ "$help_flag" == "1" ] ; then
  455. echo "***************************************"
  456. echo "* PF-build.sh Version: 1.0.6-Build_33 *"
  457. echo "***************************************"
  458. echo "Arguments:"
  459. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  460. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  461. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  462. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  463. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  464. echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build'$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  465. echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  466. echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  467. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  468. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  469. echo
  470. echo "Brief USAGE:"
  471. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-v] [-l] [-d] [-b] [-o] [-c] [-p] [-n]"
  472. echo
  473. echo "Example:"
  474. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  475. echo " Will build all variants as multi language and final GOLD version"
  476. echo
  477. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
  478. echo " Will build MK3S multi language final GOLD firmware "
  479. echo " with current commit count number and output extra information,"
  480. echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
  481. echo
  482. exit
  483. fi
  484. #
  485. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  486. if [ -z "$variant_flag" ] ; then
  487. # Select which variant of the Prusa Firmware will be compiled, like
  488. PS3="Select a variant: "
  489. while IFS= read -r -d $'\0' f; do
  490. options[i++]="$f"
  491. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  492. select opt in "${options[@]}" "All" "Quit"; do
  493. case $opt in
  494. *.h)
  495. VARIANT=$(basename "$opt" ".h")
  496. VARIANTS[i++]="$opt"
  497. break
  498. ;;
  499. "All")
  500. VARIANT="All"
  501. VARIANTS=${options[*]}
  502. break
  503. ;;
  504. "Quit")
  505. echo "You chose to stop"
  506. exit 20
  507. ;;
  508. *)
  509. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  510. ;;
  511. esac
  512. done
  513. else
  514. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  515. VARIANTS=$variant_flag
  516. elif [ "$variant_flag" == "All" ] ; then
  517. while IFS= read -r -d $'\0' f; do
  518. options[i++]="$f"
  519. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  520. VARIANT="All"
  521. VARIANTS=${options[*]}
  522. else
  523. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  524. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  525. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  526. echo "$(tput sgr0)"
  527. exit 21
  528. fi
  529. fi
  530. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  531. #Check default language mode
  532. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  533. if [ -z "$language_flag" ] ; then
  534. PS3="Select a language: "
  535. echo
  536. echo "Which lang-build do you want?"
  537. select yn in "Multi languages" "English only"; do
  538. case $yn in
  539. "Multi languages")
  540. LANGUAGES="ALL"
  541. break
  542. ;;
  543. "English only")
  544. LANGUAGES="EN_ONLY"
  545. break
  546. ;;
  547. *)
  548. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  549. ;;
  550. esac
  551. done
  552. else
  553. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  554. LANGUAGES=$language_flag
  555. else
  556. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  557. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  558. exit 22
  559. fi
  560. fi
  561. #Check if DEV_STATUS is selected via argument '-d'
  562. if [ ! -z "$devel_flag" ] ; then
  563. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  564. DEV_STATUS_SELECTED=$devel_flag
  565. else
  566. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  567. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  568. exit 23
  569. fi
  570. fi
  571. #Check if Build is selected via argument '-b'
  572. if [ ! -z "$build_flag" ] ; then
  573. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  574. echo "Build changed to $build_flag"
  575. BUILD=$(git rev-list --count HEAD)
  576. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  577. BUILD=$build_flag
  578. else
  579. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  580. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  581. exit 24
  582. fi
  583. echo "New Build number is: $BUILD"
  584. fi
  585. # check if script has been started with arguments
  586. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  587. OUTPUT=1
  588. else
  589. OUTPUT=0
  590. fi
  591. #echo "Output is:" $OUTPUT
  592. #Check git branch has changed
  593. if [ ! -z "git_available" ]; then
  594. BRANCH=""
  595. CLEAN_PF_FW_BUILD=0
  596. else
  597. BRANCH=$(git branch --show-current)
  598. echo "Current branch is:" $BRANCH
  599. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  600. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  601. echo "created PF-build.branch file"
  602. else
  603. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  604. echo "Previous branch was:" $PRE_BRANCH
  605. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  606. CLEAN_PF_FW_BUILD=1
  607. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  608. fi
  609. fi
  610. fi
  611. #Set BUILD_ENV_PATH
  612. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 25
  613. BUILD_ENV_PATH="$( pwd -P )"
  614. cd ../..
  615. #Checkif BUILD_PATH exists and if not creates it
  616. if [ ! -d "Prusa-Firmware-build" ]; then
  617. mkdir Prusa-Firmware-build || exit 26
  618. fi
  619. #Set the BUILD_PATH for Arduino IDE
  620. cd Prusa-Firmware-build || exit 27
  621. BUILD_PATH="$( pwd -P )"
  622. #Check git branch has changed
  623. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  624. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  625. rm -r *
  626. else
  627. echo "Nothing to clean up"
  628. fi
  629. for v in ${VARIANTS[*]}
  630. do
  631. VARIANT=$(basename "$v" ".h")
  632. # Find firmware version in Configuration.h file and use it to generate the hex filename
  633. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  634. if [ -z "$BUILD" ] ; then
  635. # Find build version in Configuration.h file and use it to generate the hex filename
  636. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  637. else
  638. # Find and replace build version in Configuration.h file
  639. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  640. echo "Original build number: $BUILD_ORG"
  641. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  642. fi
  643. # Check if the motherboard is an EINSY and if so only one hex file will generated
  644. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  645. # Check development status
  646. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  647. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  648. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  649. DEV_STATUS="RC"
  650. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  651. DEV_STATUS="ALPHA"
  652. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  653. DEV_STATUS="BETA"
  654. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  655. DEV_STATUS="DEVEL"
  656. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  657. DEV_STATUS="DEBUG"
  658. else
  659. DEV_STATUS="UNKNOWN"
  660. echo
  661. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  662. PS3="Select YES only if source code is tested and trusted: "
  663. select yn in "Yes" "No"; do
  664. case $yn in
  665. Yes)
  666. DEV_STATUS="GOLD"
  667. DEV_STATUS_SELECTED="GOLD"
  668. break
  669. ;;
  670. No)
  671. DEV_STATUS="UNKNOWN"
  672. DEV_STATUS_SELECTED="UNKNOWN"
  673. break
  674. ;;
  675. *)
  676. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  677. ;;
  678. esac
  679. done
  680. fi
  681. else
  682. DEV_STATUS=$DEV_STATUS_SELECTED
  683. fi
  684. #Prepare hex files folders
  685. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  686. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  687. fi
  688. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  689. #Check if exactly the same hexfile already exists
  690. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  691. echo ""
  692. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  693. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  694. if [ $OUTPUT == "1" ] ; then
  695. read -t 10 -p "Press Enter to continue..."
  696. fi
  697. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  698. echo ""
  699. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  700. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  701. if [ $OUTPUT == "1" ] ; then
  702. read -t 10 -p "Press Enter to continue..."
  703. fi
  704. fi
  705. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  706. echo ""
  707. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  708. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  709. if [ $OUTPUT == "1" ] ; then
  710. read -t 10 -p "Press Enter to continue..."
  711. fi
  712. fi
  713. #List some useful data
  714. echo "$(tput setaf 2)$(tput setab 7) "
  715. echo "Variant :" $VARIANT
  716. echo "Firmware :" $FW
  717. echo "Build # :" $BUILD
  718. echo "Dev Check :" $DEV_CHECK
  719. echo "DEV Status :" $DEV_STATUS
  720. echo "Motherboard:" $MOTHERBOARD
  721. echo "Languages :" $LANGUAGES
  722. echo "Hex-file Folder:" $OUTPUT_FOLDER
  723. echo "$(tput sgr0)"
  724. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  725. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  726. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  727. else
  728. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  729. if [ $OUTPUT == "1" ] ; then
  730. read -t 10 -p "Press Enter to continue..."
  731. fi
  732. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  733. fi
  734. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  735. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  736. # set FW_REPOSITORY
  737. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  738. #Prepare English only or multi-language version to be build
  739. if [ $LANGUAGES == "EN_ONLY" ]; then
  740. echo " "
  741. echo "English only language firmware will be built"
  742. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  743. echo " "
  744. else
  745. echo " "
  746. echo "Multi-language firmware will be built"
  747. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  748. echo " "
  749. fi
  750. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  751. # if [ $TARGET_OS == "windows" ]; then
  752. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  753. # fi
  754. #### End of Prepare building
  755. #### Start building
  756. export ARDUINO=$BUILD_ENV_PATH
  757. #echo $BUILD_ENV_PATH
  758. #export BUILDER=$ARDUINO/arduino-builder
  759. echo
  760. #read -t 5 -p "Press Enter..."
  761. echo
  762. echo "Start to build Prusa Firmware ..."
  763. echo "Using variant $VARIANT$(tput setaf 3)"
  764. if [ $OUTPUT == "1" ] ; then
  765. sleep 2
  766. fi
  767. #New fresh PF-Firmware-build
  768. if [ "$new_build_flag" == "1" ]; then
  769. rm -r -f $BUILD_PATH/* || exit 36
  770. fi
  771. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  772. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 30
  773. echo "$(tput sgr 0)"
  774. if [ $LANGUAGES == "ALL" ]; then
  775. echo "$(tput setaf 2)"
  776. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  777. echo "$(tput sgr 0)"
  778. if [ $OUTPUT == "1" ] ; then
  779. sleep 2
  780. fi
  781. cd $SCRIPT_PATH/lang
  782. echo "$(tput setaf 3)"
  783. ./config.sh || exit 31
  784. echo "$(tput sgr 0)"
  785. # Check if previous languages and firmware build exist and if so clean them up
  786. if [ -f "lang_en.tmp" ]; then
  787. echo ""
  788. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  789. if [ $OUTPUT == "1" ] ; then
  790. read -t 10 -p "Press Enter to continue..."
  791. fi
  792. echo "$(tput setaf 3)"
  793. ./lang-clean.sh
  794. echo "$(tput sgr 0)"
  795. fi
  796. if [ -f "progmem.out" ]; then
  797. echo ""
  798. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  799. if [ $OUTPUT == "1" ] ; then
  800. read -t 10 -p "Press Enter to continue..."
  801. fi
  802. echo "$(tput setaf 3)"
  803. ./fw-clean.sh
  804. echo "$(tput sgr 0)"
  805. fi
  806. # build languages
  807. echo "$(tput setaf 3)"
  808. ./lang-build.sh || exit 32
  809. # Combine compiled firmware with languages
  810. ./fw-build.sh || exit 33
  811. cp not_tran.txt not_tran_$VARIANT.txt
  812. cp not_used.txt not_used_$VARIANT.txt
  813. echo "$(tput sgr 0)"
  814. # Check if the motherboard is an EINSY and if so only one hex file will generated
  815. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  816. # If the motherboard is an EINSY just copy one hexfile
  817. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  818. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  819. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  820. else
  821. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  822. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  823. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  824. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  825. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  826. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  827. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  828. if [ $TARGET_OS == "windows" ]; then
  829. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  830. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  831. elif [ $TARGET_OS == "linux" ]; then
  832. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  833. fi
  834. fi
  835. # Cleanup after build
  836. if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
  837. echo "$(tput setaf 3)"
  838. ./fw-clean.sh || exit 34
  839. ./lang-clean.sh || exit 35
  840. echo "$(tput sgr 0)"
  841. fi
  842. else
  843. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  844. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  845. fi
  846. # Cleanup Firmware
  847. if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
  848. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  849. fi
  850. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  851. then
  852. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  853. fi
  854. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  855. then
  856. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  857. fi
  858. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  859. then
  860. rm $SCRIPT_PATH/lang/not_tran.txt
  861. fi
  862. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  863. then
  864. rm $SCRIPT_PATH/lang/not_used.txt
  865. fi
  866. #New fresh PF-Firmware-build
  867. if [ "$new_build_flag" == "1" ]; then
  868. rm -r -f $BUILD_PATH/* || exit 36
  869. fi
  870. # Restore files to previous state
  871. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  872. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  873. if [ ! -z "$BUILD_ORG" ] ; then
  874. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  875. fi
  876. echo $MULTI_LANGUAGE_CHECK
  877. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  878. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  879. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  880. if [ $OUTPUT == "1" ] ; then
  881. sleep 5
  882. fi
  883. done
  884. # Switch to hex path and list build files
  885. cd $SCRIPT_PATH
  886. cd ..
  887. echo "$(tput setaf 2) "
  888. echo " "
  889. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  890. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  891. #### End building